<template lang="pug">
.chat
	.card.messages.has-background-light
		.card-content
			template( v-if='messages.length' v-for='(message, i) in messages' :key='i' )
				b-message(
					:type='message.uSender ? "admin" : "client"'
					:caption='message.content'
					:image='message.photo'
					:file='message.file'
					:watched='message.watched'
					:edited='message.edited'
					:sender='message.uSender || message.cSender'
					:sended='message.sended'
					:created-at='message.createdAt'
					:updated-at='message.updatedAt'
					:files='message.extras'
					@retry-send='emit("retrySend", message.id)')

			template( v-else )
				.content.is-marginless
					p.is-size-4.has-text-centered.has-text-weight-bold Пока что в диалоге нет сообщений
	hr
	form.reply-container( @submit.prevent='sendMessage' )
		.block( v-if='message' )
			.columns.is-flex( v-if='message.images && message.images.length' )
				.column.is-narrow( v-for='(file, i) in message.images' :key='i' )
					b-file( :file='file' type="image" @remove='message.images.splice(i, 1)' )

			.columns.is-flex( v-if='message.files && message.files.length' )
				.column.is-narrow( v-for='(file, i) in message.files' :key='i' )
					b-file( :file='file' type="file" @remove='message.files.splice(i, 1)' )
		.block.is-flex.is-justify-content-flex-start
			.input-field.is-flex-grow-1
				b-input( v-model='message' @submit='sendMessage' )
			button.button.is-small.is-link.reply( :disabled='!message' :class='{ "is-loading": pending }' )
				span.icon
					i.fa-solid.fa-paper-plane
</template>

<script setup>
import BFile from "@/components/chat/File.vue"
import BInput from "@/components/chat/Input.vue"
import BMessage from "@/components/chat/message.vue"

import { nextTick, onMounted, ref, watch } from "vue"

const props = defineProps({
	messages: {
		type: Array,
		default: () => []
	},
	pending: Boolean
})
const emit = defineEmits([ "sendMessage", "retrySend" ])

const message = ref(null)

const toBottom = () => {
	nextTick(() => {
		const element = document.querySelector(".messages");
		element.scrollTop = element.scrollHeight
	})
}

watch(() => [ ...props.messages ], toBottom)

const sendMessage = () => {
	if (!message.value) return
	emit("sendMessage", message.value)
	nextTick(() => message.value = {})
}

onMounted(toBottom)
</script>

<style lang="scss" scoped>
.messages {
	max-height: 50rem;
	overflow-x: hidden;
	overflow-y: auto;
	box-shadow: 
		inset 0 0.5em 1em -0.125em rgba($scheme-invert, 0.1), 
		inset 0 0px 0 1px rgba($scheme-invert, 0.02);
}

hr {
	margin: .5rem 0;
}

.button.reply {
	// height: calc(100% - 30px - .75rem);
	height: unset;
	// margin-top: calc(30px + .75rem);
	margin-left: .5rem;
}
</style>